import { createRequire } from 'module';
var require = createRequire(import.meta['url']);

var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};

// ../../node_modules/.pnpm/@modern-js+module-tools@2.49.3_eslint@8.57.0_typescript@5.4.5/node_modules/@modern-js/module-tools/shims/esm.js
import { fileURLToPath } from "url";
import path from "path";

// src/index.ts
import { VueLoaderPlugin } from "vue-loader";

// src/VueLoader15PitchFixPlugin.ts
var VueLoader15PitchFixPlugin = class {
  constructor() {
    __publicField(this, "name", "VueLoader15PitchFixPlugin");
  }
  apply(compiler) {
    const { NormalModule } = compiler.webpack;
    compiler.hooks.compilation.tap(this.name, (compilation) => {
      const isExpCssOn = compilation.compiler.options?.experiments?.css;
      if (!isExpCssOn)
        return;
      NormalModule.getCompilationHooks(compilation).loader.tap(
        this.name,
        (loaderContext) => {
          if (
            // the related issue only happens for <style>
            /[?&]type=style/.test(loaderContext.resourceQuery) && // the fix should be applied before `pitch` phase completed.
            // once `pitch` phase completed, vue-loader will remove its pitcher loader.
            /[\\/]vue-loader[\\/]lib[\\/]loaders[\\/]pitcher/.test(
              loaderContext.loaders?.[0]?.path || ""
            )
          ) {
            const seen = /* @__PURE__ */ new Set();
            const loaders = [];
            for (const loader of loaderContext.loaders || []) {
              const identifier = typeof loader === "string" ? loader : loader.path + loader.query;
              if (!seen.has(identifier)) {
                seen.add(identifier);
                loaders.push(loader);
              }
            }
            loaderContext.loaders = loaders;
          }
        }
      );
    });
  }
};

// src/splitChunks.ts
import { createCacheGroups, isPlainObject } from "@rsbuild/shared";
var applySplitChunksRule = (api, options = {
  vue: true,
  router: true
}) => {
  api.modifyBundlerChain((chain) => {
    const config = api.getNormalizedConfig();
    if (config.performance.chunkSplit.strategy !== "split-by-experience") {
      return;
    }
    const currentConfig = chain.optimization.splitChunks.values();
    if (!isPlainObject(currentConfig)) {
      return;
    }
    const extraGroups = {};
    if (options.vue) {
      extraGroups.vue = ["vue", "vue-loader"];
    }
    if (options.router) {
      extraGroups.router = ["vue-router"];
    }
    if (!Object.keys(extraGroups).length) {
      return;
    }
    chain.optimization.splitChunks({
      ...currentConfig,
      // @ts-expect-error Rspack and Webpack uses different cacheGroups type
      cacheGroups: {
        ...currentConfig.cacheGroups,
        ...createCacheGroups(extraGroups)
      }
    });
  });
};

// src/index.ts
function pluginVue2(options = {}) {
  return {
    name: "rsbuild:vue2",
    setup(api) {
      const VUE_REGEXP = /\.vue$/;
      const CSS_MODULES_REGEX = /\.modules?\.\w+$/i;
      api.modifyRsbuildConfig((config) => {
        var _a;
        config.output || (config.output = {});
        (_a = config.output).cssModules || (_a.cssModules = {});
        if (config.output.cssModules.auto === true) {
          config.output.cssModules.auto = (path2, query) => {
            if (VUE_REGEXP.test(path2)) {
              return query.includes("type=style") && query.includes("module=true");
            }
            return CSS_MODULES_REGEX.test(path2);
          };
        }
        return config;
      });
      api.modifyBundlerChain((chain, { CHAIN_ID }) => {
        chain.resolve.extensions.add(".vue");
        if (!chain.resolve.alias.get("vue$")) {
          chain.resolve.alias.set("vue$", "vue/dist/vue.runtime.esm.js");
        }
        const userLoaderOptions = options.vueLoaderOptions ?? {};
        const compilerOptions = {
          preserveWhitespace: false,
          ...userLoaderOptions.compilerOptions
        };
        const vueLoaderOptions = {
          experimentalInlineMatchResource: true,
          ...userLoaderOptions,
          compilerOptions
        };
        chain.module.rule(CHAIN_ID.RULE.VUE).test(VUE_REGEXP).use(CHAIN_ID.USE.VUE).loader(__require.resolve("vue-loader")).options(vueLoaderOptions);
        chain.plugin(CHAIN_ID.PLUGIN.VUE_LOADER_PLUGIN).use(VueLoaderPlugin);
        chain.plugin(CHAIN_ID.PLUGIN.VUE_LOADER_15_PITCH_FIX_PLUGIN).use(VueLoader15PitchFixPlugin);
      });
      applySplitChunksRule(api, options.splitChunks);
    }
  };
}
export {
  pluginVue2
};
